#!/bin/bash

# Dante Security Scanner 2.1
# Marc Ruef <marc.ruef@computec.ch>
# http://www.computec.ch

# Daten ins Logfile schreiben
#echo -e "`date`\t$REMOTE_ADDR\t$QUERY_STRING\t$HTTP_USER_AGENT" >> /var/log/dante.log

# Versionsnummer und Sprache
VER="2.1"
LANG="de"

# Deklaration des Datentyps
echo -e "Content-type: text/html\n"

# Den HTML-Header laden
echo "<html>"
echo "<head>"
echo " <title>Dante Security Scanner $VER [$LANG]</title>"
echo " <meta name=Description content=Freier Online-Securityscanner>"
echo " <meta name=Keywords content=security, scanner, securityscanner, audit, penetration, exploit, dante, report, nessus, netrecon, nmap, portscan, online scanner, hacker, cracker>"
echo " <meta name=Author content=Marc Ruef>"
echo " <meta http-equiv=Content-Type content=text/html; charset=windows-1252>"
echo " <meta http-equiv=Content-Language content=$LANG>"
echo " <meta http-equiv=expires content=10>"
echo "</head>"
echo "<body text=#000000 bgcolor=#FFFFFF link=#0000EE vlink=#551A8B alink=#FF0000>"

# Das Plugin-Verzeichnis festlegen. Im Normalfall "plugins"
PLUGINDIR="plugins"

# Modus ueberpruefen
if [ -z "$QUERY_STRING" ]
then # Falls nix eingegeben wurde, die Eingabemaske anzeigen

    # Den Dante-Header laden
    echo "<h1><b>Dante Security Scanner $VER</b></h1>"

    if [ ! "$HTTP_VIA" -o ! "$HTTP_FORWARDED" ]
    then # Falls kein Proxy benutzt wird, dann gibts die Maske

	ANZAHL_PLUGINS=`ls $PLUGINDIR | wc -l`
    
	echo "Es wurden $ANZAHL_PLUGINS Plugins geladen.<br><br>"
	echo "In welchem Modus soll der Scan durchgef&uuml;hrt werden?<br>"
	echo "<form action=scan.cgi method=get>"
	echo "<input type=radio name=modus value=heavy checked> Heavy (ca. 5 Minuten)<br>"
	echo "<input type=radio name=modus value=medium> Medium (ca. 3 Minuten)<br>"
	echo "<input type=radio name=modus value=light> Light (ca. 2 Minuten)<br><br>"
#	echo "<input size=20 maxlenght=30 value=\"$REMOTE_ADDR\" name=target><br><br>"
        echo "<b>Disclaimer:</b> Ja, $REMOTE_ADDR ist die &ouml;ffentliche IP-Adresse meines Rechners und ich benutze keinen Proxy.<br><br>"
	echo "<input type=submit value=Start> <input type=reset value=Abbrechen>"
	echo "</form>"

    else # Falls ein Proxy benutzt wird, dann gibt es eine Fehlermeldung
    
	echo "Es tut mir leid, aber Sie scheinen einen Proxy ($HTTP_VIA) zu nutzen.<br><br>"
	echo "Da nicht unerlaubt fremde Proxies, zum Beispiel jene von ISPs, gescannt werden d&uuml;rfen, k&ouml;nnen nun keine Scans ausgef&uuml;hrt werden.<br><br>"
	echo "Schalten Sie das Nutzen des Proxies ab, um den Dante Security Scanner $VER gebrauchen zu k&ouml;nnen.<br><br>"
    
    fi

else # Falls eine Eingabe getaetigt wurde, dann fuehren wir den Scan aus

    # Die Eingabe wird entsprechend umgewandelt, damit wirs verarbeiten koennen
    MODUS=`echo "$QUERY_STRING" | awk 'BEGIN{FS="&"}{print $1}' |sed s/"modus="//`
    TARGET=`echo "$QUERY_STRING" | awk 'BEGIN{FS="&"}{print $2}' |sed s/"target="//`

    # Falls kein Target eingegeben wurde, dann nehmen wir einfach REMOTE_ADDR,
    # also die IP-Adresse des Surfers.
    if [ -z "$TARGET" ]
    then
	TARGET="$REMOTE_ADDR"
    fi
    
    # Der Report-Header wird geschrieben
    echo "<a name=oben><center><h1><b>Dante Report f&uuml;r $TARGET</b></h1>"
    echo "Dante Security Scanner $VER<br>"
    echo "`date -R`<br>"
    echo "$HTTP_USER_AGENT<br>"
    echo "Zielsystem: $TARGET<br>"
    echo "Scanmodus: $MODUS<br><br>"
    echo "</center>"
    
    # Die verschiedenen Modi und ihre Prozeduren
    # Der Light-Mode
    lightmodecmd() {
	for PLUGIN in http_user_agent_auslesen.plugin windows_95_entdecken.plugin windows_98_entdecken.plugin windows_me_entdecken.plugin windows_nt_4_0_entdecken.plugin windows_2000_entdecken.plugin windows_xp_entdecken.plugin linux_entdecken.plugin whois.plugin nslookup.plugin icmp_echo_request.plugin traceroute-icmp.plugin tcp-portscan.plugin netbios-freigaben.plugin http-html-quelltext_analysieren.plugin tcp-port-12345.plugin
	do
	    $PLUGINDIR/$PLUGIN $TARGET &
	    echo -e "\n<!-- $PLUGIN gestartet -->\n"
	    sleep 1
	done
    }
    
    # Der Medium-Mode
    mediummodecmd() {
	lightmodecmd	# Den Light-Mode zuerst ausfuehren
	for PLUGIN in nfs-freigaben.plugin mailadresse_auslesen.plugin ip_in_google_suchen.plugin traceroute-udp.plugin unverschluesseltes_telnet.plugin banner-grabbing-21.plugin banner-grabbing-22.plugin banner-grabbing-23.plugin banner-grabbing-25.plugin banner-grabbing-80.plugin banner-grabbing-110.plugin banner-grabbing-443.plugin anonymes_ftp.plugin esmtp.plugin http-404_analysieren.plugin http-robots-txt.plugin
	do
	    $PLUGINDIR/$PLUGIN $TARGET &
	    echo -e "\n<!-- $PLUGIN gestartet -->\n"
	    sleep 1
	done
    }
    
    # Der Heavy-Mode
    heavymodecmd() {
	mediummodecmd	# Den Medium-Mode zuerst ausfuehren
	for PLUGIN in rpcinfo.plugin finger_auf_root.plugin sendmail_finden.plugin apache_finden.plugin ms_iis_3_0_finden.plugin ms_iis_4_0_finden.plugin ms_iis_5_0_finden.plugin ms_iis_5_1_finden.plugin sshd-1-2-27-bufferoverflow.plugin http-etc-passwd.plugin ms_iis_ida.plugin ms_iis_isapi-bufferoverflow.plugin ws_ftp_log.plugin http-test-cgi.plugin firewall-tcp-acl.plugin
	do
	    $PLUGINDIR/$PLUGIN $TARGET &
	    echo -e "\n<!-- $PLUGIN gestartet -->\n"
	    sleep 1
	done
    }

    # Welcher Modus wurde gewaehlt? Er wird dann gestartet.
    if [ $MODUS = heavy ]
    then # Der Light-Modus wird geladen
	heavymodecmd

    elif [ $MODUS = medium ]
    then  # Der Light-Modus wird geladen
	mediummodecmd

    elif [ $MODUS = light ]
    then # Der Easy-Modus
	lightmodecmd

    fi

    # Lass uns auf die Child-Prozesse warten, damit wir kein Durcheinander kriegen
    wait

    # Die Statistik ausgeben
    echo "Der Scan im $MODUS-Modus ist erfolgreich beendet. Er ben&ouml;tigte $SECONDS Sekunden.<br><br>"

    # Den Dante-Footer laden
    echo "[<a href=$SCRIPT_NAME>Neuer Scan</a>] 
    [<a href='javascript:window.print()'>Report drucken</a>]"

    # Alle temporaeren Dateien aufraeumen
    rm /tmp/*-$TARGET
    
fi

# Den Rest des Dante-Footer laden
echo "[<a href=http://www.computec.ch target=_TOP>Hilfe</a>] 
[<a href='javascript:home()'>Dante Verlassen</a>]<br><br>
<hr size=1 noshade width=100%>
<font size=-2>Dieses Dokument wurde durch den Security Scanner des Dante
Projekts generiert - <a href=http://www.computec.ch target=_TOP>
http://www.computec.ch</a></font><a name=unten>"

# Den HTML-Footer laden
echo "</html>"
